Attribute VB_Name = "KotrolDroite"
Option Explicit

Private Const SYNCHRONIZE As Long = &H100000
Private Const ANYSIZE_ARRAY = 1
Private Const OWNER_SECURITY_INFORMATION As Long = &H1
Private Const GROUP_SECURITY_INFORMATION As Long = &H2
Private Const DACL_SECURITY_INFORMATION  As Long = &H4
Private Const FS_PERSISTENT_ACLS As Long = &H8
Private Const SecurityImpersonation As Integer = 3
Private Const TOKEN_QUERY As Long = 8
Private Const READ_CONTROL As Long = &H20000
Private Const STANDARD_RIGHTS_READ As Long = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE As Long = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE As Long = READ_CONTROL
Private Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
Private Const FILE_EXECUTE As Long = &H20
Private Const FILE_APPEND_DATA As Long = &H4
Private Const FILE_READ_DATA As Long = &H1
Private Const FILE_WRITE_DATA As Long = &H2
Private Const FILE_READ_ATTRIBUTES As Long = &H80
Private Const FILE_WRITE_ATTRIBUTES As Long = &H100
Private Const FILE_READ_EA As Long = &H8
Private Const FILE_WRITE_EA As Long = &H10
Private Const FILE_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &H1FF)
Private Const VER_PLATFORM_WIN32_NT As Long = 2

Public Const MAXIMUM_ALLOWED As Long = &H2000000
Public Const FILE_GENERIC_READ As Long = (STANDARD_RIGHTS_READ Or FILE_READ_DATA Or FILE_READ_ATTRIBUTES Or FILE_READ_EA Or SYNCHRONIZE)
Public Const FILE_GENERIC_WRITE As Long = (STANDARD_RIGHTS_WRITE Or FILE_WRITE_DATA Or FILE_WRITE_ATTRIBUTES Or FILE_WRITE_EA Or FILE_APPEND_DATA Or SYNCHRONIZE)
Public Const FILE_GENERIC_EXECUTE As Long = (STANDARD_RIGHTS_EXECUTE Or FILE_READ_ATTRIBUTES Or FILE_EXECUTE Or SYNCHRONIZE)

Private Declare Sub MapGenericMask Lib "advapi32.dll" (AccessMask As Long, GenericMapping As GENERIC_MAPPING)

Private Declare Function AccessCheck Lib "advapi32.dll" (pSecurityDescriptor As Byte, ByVal ClientToken As Long, ByVal DesiredAccess As Long, GenericMapping As GENERIC_MAPPING, PrivilegeSet As PRIVILEGE_SET, PrivilegeSetLength As Long, GrantedAccess As Long, Status As Long) As Long
Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetFileSecurity Lib "advapi32.dll" Alias "GetFileSecurityA" (ByVal lpFileName As String, ByVal RequestedInformation As Long, pSecurityDescriptor As Byte, ByVal nLength As Long, lpnLengthNeeded As Long) As Long
Private Declare Function ImpersonateSelf Lib "advapi32.dll" (ByVal ImpersonationLevel As Integer) As Long
Private Declare Function GetCurrentThread Lib "kernel32" () As Long
Private Declare Function OpenThreadToken Lib "advapi32.dll" (ByVal ThreadHandle As Long, ByVal DesiredAccess As Long, ByVal OpenAsSelf As Long, TokenHandle As Long) As Long

Private Type LUID
    LowPart As Long
    HighPart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
    pLuid As LUID
    Attributes As Long
End Type

Private Type PRIVILEGE_SET
    PrivilegeCount As Long
    Control As Long
    Privilege(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Private Type GENERIC_MAPPING
    GenericRead As Long
    GenericWrite As Long
    GenericExecute As Long
    GenericAll As Long
End Type

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function RevertToSelf Lib "advapi32.dll" () As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public Function CheckFileAccess(Filename As String, ByVal DesiredAccess As Long) As Long
    
    Dim Tmp0 As Long, Volume As String
    
    Dim SecDesc() As Byte, SDSize As Long, hToken As Long
    Dim PrivSet As PRIVILEGE_SET, GenMap As GENERIC_MAPPING
    Dim FSFlags As Long
                                                ' verification: type du systeme (winXP, winNT ou win2000)
    If Not IsNT() Then CheckFileAccess = -1: Exit Function
                                                ' verification: le systeme de fichier support les droit d'acces
    If Left$(Filename, 2) = "\\" Then           ' chemin sous format UNC
        Tmp0 = InStr(3, Filename, "\")
        If Tmp0 = 0 Then Volume = Filename & "\" Else Volume = Left$(Filename, Tmp0 - 1)
    ElseIf Mid$(Filename, 2, 2) = ":\" Then
        Volume = Left$(Filename, 3)             ' recuperation du nom du disque
    End If                                      ' si ni l'en ni l'autre, laisson Volume vide, on recuper l'information sur "current" disque

    ' recuperon l'information sur le disque
    GetVolumeInformation Volume, vbNullString, 0, ByVal 0&, ByVal 0&, FSFlags, vbNullString, 0
    If (FSFlags And FS_PERSISTENT_ACLS) = 0 Then CheckFileAccess = -1: Exit Function

    ' recuperation de la taille du "bufer"
    GetFileSecurity Filename, OWNER_SECURITY_INFORMATION Or GROUP_SECURITY_INFORMATION _
        Or DACL_SECURITY_INFORMATION, 0, 0, SDSize
    If Err.LastDllError <> 122 Then CheckFileAccess = -1: Exit Function

    If SDSize = 0 Then Exit Function
    ReDim SecDesc(1 To SDSize)                  ' selection du "bufer"

    ' rerappel la function encore une fois pour obtenir Security Descriptor
    If GetFileSecurity(Filename, OWNER_SECURITY_INFORMATION Or GROUP_SECURITY_INFORMATION _
        Or DACL_SECURITY_INFORMATION, SecDesc(1), SDSize, SDSize) = 0 Then Exit Function

    ImpersonateSelf SecurityImpersonation
    OpenThreadToken GetCurrentThread(), TOKEN_QUERY, 0, hToken
    If hToken <> 0 Then
        GenMap.GenericRead = FILE_GENERIC_READ
        GenMap.GenericWrite = FILE_GENERIC_WRITE
        GenMap.GenericExecute = FILE_GENERIC_EXECUTE
        GenMap.GenericAll = FILE_ALL_ACCESS
        MapGenericMask DesiredAccess, GenMap
        AccessCheck SecDesc(1), hToken, DesiredAccess, GenMap, _
            PrivSet, Len(PrivSet), CheckFileAccess, Tmp0
        CloseHandle hToken
    End If

    RevertToSelf
End Function

Private Function IsNT() As Boolean
    Dim OSVer As OSVERSIONINFO
    OSVer.dwOSVersionInfoSize = Len(OSVer)
    GetVersionEx OSVer
    IsNT = (OSVer.dwPlatformId = VER_PLATFORM_WIN32_NT)
End Function


